package widebase.stream.codec

import org.jboss.netty.buffer. { ChannelBuffer, ChannelBuffers }
import org.jboss.netty.channel.Channel
import org.jboss.netty.channel.ChannelHandlerContext
import org.jboss.netty.handler.codec.oneone.OneToOneEncoder

/** Encode requests.
 *
 * @author myst3r10n
 */
class RequestEncoder extends OneToOneEncoder with MessageTypeEncoder {

  @throws(classOf[Exception])
  override def encode(
    ctx: ChannelHandlerContext,
    channel: Channel,
    msg: Object): Object = writeMessage(ChannelBuffers.dynamicBuffer, msg)

  protected def writeMessage(buffer: ChannelBuffer, message: Object): Object = {

    message match {

      case message: LoginMessage =>
        writeId(buffer, MessageType.LoginMessage.id)
        writeString(buffer, message.username)
        writeString(buffer, message.password)

      case message: RemoteShutdownMessage => writeId(buffer, MessageType.RemoteShutdownMessage.id)
      case message => return message

    }

    finish(buffer)

    buffer

  }
}

